<xsl:stylesheet version='1.0'
	xmlns:xsl='http://www.w3.org/1999/XSL/Transform'>

	<!-- If using xsltproc the 'html' option must be used  -->
	<xsl:output method="xml" indent="yes" />
	<xsl:template match="/">
		<DaCS_topology version="2.0">
			<hardware>
				<xsl:for-each select="//hardware">
					<xsl:for-each select="./de">
						<de>
						<xsl:attribute name="name">
							<xsl:value-of select="." />
							<xsl:value-of select="@tag" />
						</xsl:attribute>
							<xsl:attribute name="type">
							<xsl:value-of select="." />
							<xsl:value-of select="@type" />
						</xsl:attribute>
						<xsl:for-each select="./de">
							<de>
							<xsl:attribute name="name">
								<xsl:value-of select="." />
								<xsl:value-of select="@tag" />
							</xsl:attribute>
							<xsl:attribute name="type">
								<xsl:value-of select="." />
								<xsl:value-of select="@type" />
							</xsl:attribute>
							</de>
							</xsl:for-each>
						</de>
					</xsl:for-each>
				</xsl:for-each>
			</hardware>
			<topology>
				<xsl:for-each select="//canreserve">
					<canReserve>
						<xsl:attribute name="he">
							<xsl:value-of select="." />
							<xsl:value-of select="@he" />
						</xsl:attribute>
						<xsl:attribute name="ae">
							<xsl:value-of select="." />
							<xsl:value-of select="@ae" />
						</xsl:attribute>
						<xsl:if test="@only != ''">
							<xsl:attribute name="only">
								<xsl:value-of select="@only" />
							</xsl:attribute>
						</xsl:if>
					</canReserve>
				</xsl:for-each>
			</topology>
			<processManagement>
				<xsl:for-each select="//de">
					<xsl:if test="@ip != ''">
						<mgtDe>
							<xsl:attribute name="deName">
							<xsl:value-of select="." />
							<xsl:value-of select="@tag" />
						</xsl:attribute>
							<xsl:attribute name="fabric">
							<xsl:text>IP</xsl:text>
						</xsl:attribute>
							<xsl:attribute name="connInfo">
							<xsl:value-of select="." />
							<xsl:value-of select="@ip" />
						</xsl:attribute>
						</mgtDe>
					</xsl:if>
				</xsl:for-each>
			</processManagement>
                        <communications>
                          <fabrics default="IP">
                            <fabric type="IP" device="TCP" /> 
                          </fabrics>
                          <connections>
                             <xsl:comment> One connection needed per Opteron core to CBE connection </xsl:comment>
                             <connection endPt1="COREx" endPt2="CBEx" >
                               <forFabric type="IP" >
                                  <from1to2 connInfo="xx.xx.xx.xx" />
                                  <from2to1 connInfo="xx.xx.xx.xx" /> 
                               </forFabric>
                             </connection>
                          </connections>
                        </communications>
		</DaCS_topology>
	</xsl:template>

</xsl:stylesheet>
